#include "AllMatcher.h"

#pragma warning (disable: 4786)

#include <algorithm>
#include <iterator>

class rowPred{
public:
	bool operator()(const tRow::value_type& x, const tRow::value_type& y){
		return (x.first < y.first);
	}
};

int AllMatcher::match(const Vector<tTerm>& queryTerms, Set<tMatchResult>& result)
{
	result.clear();
	tRow intersectionRow;

	UINT matchedDocs = 0;

	if (queryTerms.size() == 0)
		return 0;
	// get the first term from the query
	tTerm term = queryTerms[0];
	// retrieve the documents that the first term appears in
	const tRow* row = SearchEngine::instance().getTermDocuments(term);
	if (row == NULL)
		return 0;
	intersectionRow = *row;
	
	for (int i = 1; i < queryTerms.size(); i++) {
		// get next term from the query
		term = queryTerms[i];
		// retrieve the documents that this current term appears in
		row = SearchEngine::instance().getTermDocuments(term);

		if (row == NULL)
			return 0;
		//get the intersection
		tRow outputRow;

		rowPred pred;
		std::set_intersection(intersectionRow.begin(),
						 intersectionRow.end(),
						 row->begin(),
						 row->end(),
						 std::insert_iterator<tRow>(outputRow, outputRow.begin()),
						 pred);
		intersectionRow = outputRow;   
	}

	// create a result set containing all the documents in the tRow struct
	tMatchResult tRes;
	tRes.matchScore = queryTerms.size();
	for (tRow::iterator iRow = intersectionRow.begin();
		 iRow != intersectionRow.end();
		 iRow++){
		tRes.docID = iRow->first;
		if (result.size() < m_maxToMatch)
			result.insert(tRes);
		
	}

	return intersectionRow.size();
}
