#include "Tokenizer.h"

#include <fstream>

Tokenizer::Tokenizer() 
	: m_stream(NULL), m_shouldDelete(false) {}

Tokenizer::~Tokenizer()
{
	setInputStream(NULL);
}

void Tokenizer::setInput(std::istream& s)
{
	setInputStream(&s);
	m_shouldDelete = false;
}

void Tokenizer::setInput(const char* filename)
{
	setInputStream(new std::ifstream(filename));
	m_shouldDelete = true;
}

void Tokenizer::getRemainingTokens(Vector<tTerm>& tokensVector)
{
	tokensVector.clear();
	tTerm term;
	while (getNextTerm(term)) {
		tokensVector.push_back(term);
	}
}